var plugin = require('topsin.gengui');

var gui = plugin.newGui(plugin.__dirname);


r = gui.showForm({
    title: "form example",
    ui: {
        type: 'ScrollArea',
        property: {
            widget_resizable: true,
            frame_shape: 'NoFrame',
            align: 'Top'
        },
        child: {
            type: 'VBoxLayout',
            property: {
                margin: 2,
                spacing: 20,
                align: 'Top'
            },
            pack: {
                stretch: 0
            },
            child: [{
                    type: "FormGridLayout",
                    property: {
                        columns: 2,
                        label_alignment: 'Top | Right',
                        margin: 10,
                        spacing: 20
                    },
                    pack: {
                        stretch: 0
                    },
                    child: [
                        {
                            name: "org_list",
                            type: "TableView",
                            pack: {
                                column_span: 2,
                            },
                            property: {
                                enabled: true,
                                alternating_row_colors: true,
                                auto_scroll: true,
                                data_key_list: ["layer_name", "drill_type", "finish_size", "pcs_count", "array_count"],
                                data_keys: ["layer_name", "drill_type", "finish_size", "pcs_count", "array_count"],
                                values: [
                                    {},
                                    {
                                        "name": "layer_name",
                                        "display": "Layer Name",
                                        "displayRole": "$layer_name",
                                        'resizeMode': 'Interactive',
                                        "size": "100"
                                    },
                                    {
                                        "name": "drill_type",
                                        'resizeMode': 'Interactive',
                                        "display": "PTH",
                                        "displayRole": "$drill_type",
                                        "size": "100"
                                    },
                                    {
                                        "name": "finish_size",
                                        "display": "Drill size(mm)",
                                        "displayRole": "$finish_size",
                                        "resizeMode": "ResizeToContents",
                                    },
                                    {
                                        "name": "pcs_count",
                                        "display": "Qty.(CRD)",
                                        "displayRole": "$pcs_count",
                                        'resizeMode': 'Interactive',
                                        "size": "100"
                                    },
                                    {
                                        "name": "array_count",
                                        "display": "Qty.(Array)",
                                        "displayRole": "$array_count",
                                        "size": "100"
                                    }
                                ]
                            },
                            initCallback: function (obj) {
                                obj.setDataKeyList(["layer_name", "drill_type", "finish_size", "pcs_count", "array_count"]);
                                obj.setHeaderItem(
                                    [
                                        {
                                            "name": "layer_name",
                                            "display": "Layer Name",
                                            "displayRole": "$layer_name",
                                            "size": "100"
                                        },
                                        {
                                            "name": "drill_type",
                                            "display": "PTH",
                                            "displayRole": "$drill_type",
                                            "size": "100"
                                        },
                                        {
                                            "name": "finish_size",
                                            "display": "Drill size(mm)",
                                            "displayRole": "$finish_size",
                                            "resizeMode": "ResizeToContents",
                                        },
                                        {
                                            "name": "pcs_count",
                                            "display": "Qty.(CRD)",
                                            "displayRole": "$pcs_count",
                                            "size": "100"
                                        },
                                        {
                                            "name": "array_count",
                                            "display": "Qty.(Array)",
                                            "displayRole": "$array_count",
                                            "size": "100"
                                        }
                                    ]
                                );
                            },
                            // setter: function (obj, value, self) {
                            //     if (_.isEmpty(value)) {
                            //         this.setState("org_list", "hide");
                            //         this.getObject("org_list").setData("value", []);
                            //     } else {
                            //         this.setState("org_list", "show");
                            //         this.getObject("org_list").setData("value", value);
                            //     }
                            // },
                            // getter: function (obj, self) {
                            //     return obj.allDataMap();
                            // }
                        }
                    ]
                },
                {
                    type: 'stretch'
                }
            ]
        }
    },
    data: {},
    runnow: true,
    includehide: false,
    buttons: [{
            stock: "ok",
            sensitive: true,
            command: function (data) {

            }
        },
        {
            stock: "cancel",
            sensitive: true,
            command: function (ddata) {

            }
        },
        {
            stock: "help",
            sensitive: true,
            command: function (data) {
                console.log(data);
            }
        }
    ],
    hook: function (data) {},
    gen: null
});


console.log(r);




// return [
//     {
//         type: "FormGridLayout",
//         property: {
//             label_alignment: 'AlignTop | AlignRight',
//             horizontal_spacing: 20,
//             vertical_spacing: 10,
//             margin: 20
//         },
//         child: [
//             {
//                 name: "id",
//                 type: "LineEdit",
//                 title: self.ttr("Layer Name"),
//                 state: function (obj, self) {
//                     return "hide";
//                 }
//             },
//             {
//                 name: "layer_name",
//                 type: "LineEdit",
//                 title: self.ttr("Layer Name")
//             },
//             {
//                 name: "attr_data.org_layer_name",
//                 type: "LineEdit",
//                 title: self.ttr("Org Layer Name")
//             },
//             {
//                 name: "mm.finish_size",
//                 type: "DoubleLineEdit",
//                 title: self.ttr("Drill size(mm)"),
//                 validate: function (obj, val, title, moment, self) {
//                     if (val != undefined && val != null && val != "") {
//                         var milFinishSize = _.toNumber(val) * 1000 / 25.4;
//                         milFinishSize = milFinishSize.toFixed(self.config("precision.mil.finish_size"));
//                         this.getObject("mil.finish_size").setData("value", milFinishSize);
//                         this.getObject("finish_size").setData("value", _.toNumber(val) * 1000);
//                     } else {
//                         this.getObject("mil.finish_size").setData("value", null);
//                         this.getObject("finish_size").setData("value", null);
//                     }
//                 }
//             },
//             {
//                 name: "mil.finish_size",
//                 type: "DoubleLineEdit",
//                 title: self.ttr("Drill size(mil)"),
//                 property: {
//                     enabled: false
//                 }
//             },
//             {
//                 name: "finish_size",
//                 type: "DoubleLineEdit",
//                 title: self.ttr("33Drill size(mil)"),
//                 state: function (obj, self) {
//                     return "hide";
//                 }
//             },
//             {
//                 name: "mm.finish_slot_length",
//                 type: "DoubleLineEdit",
//                 title: self.ttr("Finish Slot Length"),
//                 validate: function (obj, val, title, moment, self) {
//                     if (val != undefined && val != null && val != "") {
//                         var finishSlotLength = (_.toNumber(val) * 1000).toFixed(self.config("precision.mm.finish_slot_length"));
//                         this.getObject("finish_slot_length").setData("value", finishSlotLength);
//                     } else {
//                         this.getObject("finish_slot_length").setData("value", null);
//                     }
//                 }
//             },
//             {
//                 name: "finish_slot_length",
//                 type: "DoubleLineEdit",
//                 title: self.ttr("Finish Slot Length"),
//                 state: function (obj, self) {
//                     return "hide";
//                 }
//             },
//             {
//                 name: "tool_type",
//                 type: "ComboBox",
//                 title: self.ttr("Round/slot"),
//                 property: {
//                     item_list: TOPENM.enumList("pdm-job-drill-table-tool-type").toComboList()
//                 }
//             },
//             {
//                 name: "drill_type",
//                 type: "ComboBox",
//                 title: self.ttr("PTH"),
//                 property: {
//                     item_list: TOPENM.enumList("pdm-job-drill-table-drill-type").toComboList()
//                 },
//                 validate: function (obj, val, title, moment, self) {
//                     var CRUD = this.getValue("CRUD");
//                     if (!/create/i.test(CRUD)) {
//                         return;
//                     }
//                     function numToString(num, digit) {
//                         numchar = num.toString();
//                         s = digit - numchar.length;
//                         var ch = "";
//                         for (i = 0; i < s; i++) {
//                             ch += "0";
//                         }
//                         return ch + numchar;
//                     };

//                     if (val == "laser") {
//                         this.getObject("tool_num").setData("value", "T01");
//                     } else {
//                         var allData = self.allTableDataMap();
//                         var max = 0;
//                         _.forEach(allData, function (item) {
//                             if (item["drill_type"] != "laser" && item["CRUD"] != "create") {
//                                 var tool_num = item["tool_num"];
//                                 var toolNum = _.toNumber(tool_num.replace(/\D/g, ""));
//                                 max = max > toolNum ? max : toolNum;
//                             }
//                         })
//                         max += 1;
//                         this.getObject("tool_num").setData("value", _.format("T{0}", numToString(max, 2)));
//                     }
//                 }
//             },
//             {
//                 name: "attr_data.allowance",
//                 type: "LineEdit",
//                 title: self.ttr("allowance")
//             },
//             {
//                 name: "size_tol_upper",
//                 type: "DoubleLineEdit",
//                 title: self.ttr("Tol.+")
//             },
//             {
//                 name: "size_tol_lower",
//                 type: "DoubleLineEdit",
//                 title: self.ttr("Tol.-")
//             },
//             {
//                 name: "pcs_count",
//                 type: "IntLineEdit",
//                 title: self.ttr("Qty.(CRD)")
//             },
//             {
//                 name: "array_count",
//                 type: "IntLineEdit",
//                 title: self.ttr("Qty.(Array)")
//             },
//             {
//                 name: "panel_count",
//                 type: "IntLineEdit",
//                 title: self.ttr("Qty.(Panel)")
//             },
//             {
//                 name: "mm.drill_size",
//                 type: "DoubleLineEdit",
//                 title: self.ttr("Drill bit(mm)"),
//                 validate: function (obj, val, title, moment, self) {
//                     if (val != undefined && val != null && val != "") {
//                         var finishSlotLength = (_.toNumber(val) * 1000).toFixed(self.config("precision.mm.drill_size"));
//                         this.getObject("drill_size").setData("value", finishSlotLength);
//                     } else {
//                         this.getObject("drill_size").setData("value", null);
//                     }
//                 }
//             },
//             {
//                 name: "drill_size",
//                 type: "DoubleLineEdit",
//                 title: self.ttr("Drill bit(mm)"),
//                 state: function (obj, self) {
//                     return "hide";
//                 }
//             },
//             {
//                 name: "mm.drill_slot_length",
//                 type: "DoubleLineEdit",
//                 title: self.ttr("Drill Slot Length"),
//                 validate: function (obj, val, title, moment, self) {
//                     if (val != undefined && val != null && val != "") {
//                         var finishSlotLength = (_.toNumber(val) * 1000).toFixed(self.config("precision.mm.drill_slot_length"));
//                         this.getObject("drill_slot_length").setData("value", finishSlotLength);
//                     } else {
//                         this.getObject("drill_slot_length").setData("value", null);
//                     }
//                 }
//             },
//             {
//                 name: "drill_slot_length",
//                 type: "DoubleLineEdit",
//                 title: self.ttr("Drill Slot Length"),
//                 state: function (obj, self) {
//                     return "hide";
//                 }
//             },
//             {
//                 name: "attr_data.org_list",
//                 type: "TableView",
//                 title: self.ttr("Combine Data List"),
//                 initCallback: function (obj, self) {
//                     obj.setDataKeyList(["layer_name", "drill_type", "finish_size", "pcs_count", "array_count"]);
//                     obj.setHeaderItem(
//                         [
//                             {

//                             },
//                             {
//                                 "name": "layer_name",
//                                 "display": self.ttr("Layer Name"),
//                                 "displayRole": "$layer_name",
//                                 "size": "100"
//                             },
//                             {
//                                 "name": "drill_type",
//                                 "display": self.ttr("PTH"),
//                                 "displayRole": "$drill_type",
//                                 "size": "100"
//                             },
//                             {
//                                 "name": "finish_size",
//                                 "display": self.ttr("Drill size(mm)"),
//                                 "displayRole": "$finish_size",
//                                 "resizeMode": "ResizeToContents",
//                             },
//                             {
//                                 "name": "pcs_count",
//                                 "display": self.ttr("Qty.(CRD)"),
//                                 "displayRole": "$pcs_count",
//                                 "size": "100"
//                             },
//                             {
//                                 "name": "array_count",
//                                 "display": self.ttr("Qty.(Array)"),
//                                 "displayRole": "$array_count",
//                                 "size": "100"
//                             }
//                         ]
//                     );
//                 },
//                 setter: function (obj, value, self) {
//                     if (_.isEmpty(value)) {
//                         this.setState("attr_data.org_list", "hide");
//                         this.getObject("attr_data.org_list").setData("value", []);
//                     } else {
//                         this.setState("attr_data.org_list", "show");
//                         this.getObject("attr_data.org_list").setData("value", value);
//                     }
//                 },
//                 getter: function (obj, self) {
//                     return obj.allDataMap();
//                 }
//             },
//             {
//                 name: "attr_data.depth_drilling",
//                 type: "ComboBox",
//                 title: self.ttr("Depth Drilling"),
//                 property: {
//                     item_list: [
//                         { name: "yes", text: "Yes" },
//                         { name: "no", text: "No" }
//                     ]
//                 },
//                 validate: function (obj, val, title, moment, self) {
//                     if (val == "yes") {
//                         this.setState("attr_data.depth_drilling_side", "show")
//                     } else {
//                         this.setState("attr_data.depth_drilling_side", "hide")
//                         this.getObject("attr_data.depth_drilling_side").setData("value", "");
//                     }
//                 }
//             },
//             {
//                 name: "attr_data.depth_drilling_side",
//                 type: "ComboBox",
//                 title: self.ttr("Depth Drilling Side"),
//                 property: {
//                     item_list: [
//                         { name: "front", text: "Front" },
//                         { name: "back", text: "Back" }
//                     ]
//                 }
//             },
//             {
//                 name: "CRUD",
//                 type: "LineEdit",
//                 state: function (obj, self) {
//                     return 'hide';
//                 }
//             },
//             {
//                 name: "tool_num",
//                 type: "LineEdit",
//                 state: function (obj, self) {
//                     return 'hide';
//                 }
//             },
//             {
//                 type: "Stretch"
//             }
//         ]
//     }
// ]